Listing 21.1
mysql -u movies -p movies


Listing 21.2
SELECT movie_title, gross, budget
FROM Movies; 


Listing 21.3
SELECT movie_id, movie_title
FROM Movies
WHERE movie_id IN (1, 8);

REPLACE Movies 
(movie_id, movie_title, studio_id, budget, gross, 
release_date, director_id)
VALUES
( 1, 'Another Movie', 1, 25, 35, '1987-12-01', 1);

REPLACE Movies 
(movie_id, movie_title, studio_id, budget, gross, 
release_date, director_id)
VALUES
( 8, 'The Programmer', 3, 50, 45.3, '17-APR-93', 1);

SELECT movie_id, movie_title
FROM Movies
WHERE movie_id IN (1, 8);


Listing 21.4
SHOW Movies;


Listing 21.5
SHOW TABLES FROM movies;


Listing 21.6
SELECT movie_title
FROM Movies, Studios
WHERE Movies.studio_id = Studios.studio_id
AND studio_state = 'CA'


Listing 21.7
SELECT movie_title, studio_name
FROM Movies, Studios
WHERE Movies.studio_id = Studios.studio_id
AND Movies.movie_id = 1


Listing 21.8
SELECT movie_title, studio_name
FROM Movies JOIN Studios
WHERE Movies.studio_id = Studios.studio_id
AND Movies.movie_id = 1


Listing 21.9
SELECT movie_title, studio_name
FROM Movies LEFT JOIN Studios
ON Movies.studio_id = Studios.studio_id
WHERE Movies.movie_id = 1


Listing 21.10
SELECT movie_title, studio_name
FROM Movies LEFT JOIN Studios
USING (studio_id)
WHERE Movies.movie_id = 1


Listing 21.11
SELECT movie_title, studio_name
FROM Movies NATURAL LEFT JOIN Studios
WHERE Movies.movie_id = 1


Listing 21.12
CREATE TABLE Movies
(movie_id INT NOT NULL,
movie_title CHAR(25),
studio_id INT,
budget REAL,
gross REAL,
release_date DATE.
director_id INT)


Listing 21.13
CREATE UNIQUE INDEX movie_id_index  
ON Movies (movie_id)


Listing 21.14
CREATE SEQUENCE ON Movies STEP 1 VALUE 1
\g


Listing 21.15
SELECT _seq
FROM Movies
\g


Listing 21.16
DROP SEQUENCE FROM Movies
\g


Listing 21.17
DROP INDEX movie_id_index FROM Movies
\g


Listing 21.18
DROP TABLE Movies
\g







